//-----------------------------------------------------------------------------
//    Ufw_Exh_Genb_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_exh_genb;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;

/**
 *
 * Applet is triggered on Install (Install)
 *
 *
 */

public class Ufw_Exh_Genb_1 extends TestToolkitApplet{
 
    byte    bTestCaseNb = (byte)1;
    /**
    * Constructor of the applet
    */
    public Ufw_Exh_Genb_1() {
    }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        

        
        // Create a new applet instance.
        Ufw_Exh_Genb_1 thisApplet = new Ufw_Exh_Genb_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
       
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
        thisApplet.obReg.setEvent(EVENT_UNFORMATTED_SMS_PP_ENV);
                                                           
   }


    public void processToolkit(short event)
    {
        
                
        boolean bRes = false;


        if (event == EVENT_UNFORMATTED_SMS_PP_ENV) {


            switch (bTestCaseNb){
            
                case 0x01:
                    
                    ISOException busyException = new ISOException((short)0x9300);                   
                    bRes = true;
                    reportTestOutcome ( bTestCaseNb++, bRes );
                    throw (busyException);                    
                
                case 0x02:
                
                    bRes = true;
                    reportTestOutcome ( bTestCaseNb++, bRes );
                    
            }       

        }   
        if (event == EVENT_FORMATTED_SMS_PP_ENV) {
        
        
            switch (bTestCaseNb){
            
                case 0x03:
                    
                    ISOException busyException = new ISOException((short)0x9300);                   
                    bRes = true;
                    reportTestOutcome ( bTestCaseNb++, bRes );
                    throw (busyException);
                    
                
                case 0x04:
                    
                    ISOException notBusyException = new ISOException((short)0x9005);
                    bRes = true;
                    reportTestOutcome ( bTestCaseNb++, bRes );
                    throw (notBusyException);
                    
                        
                case 0x05:
                    
                    bRes = true;
                    reportTestOutcome ( bTestCaseNb++, bRes );
                    throw (new ToolkitException(ToolkitException.REGISTRY_ERROR));
                    
                        

            }               
        
        }

    }

}


