//-----------------------------------------------------------------------------
//    Api_2_Tkr_Ievs_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_tkr_ievs;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;

/**
 * Test Area : usim.toolkit...
 *
 * Applet is triggered on Install (Install)
 *
 *
 */

public class Api_2_Tkr_Ievs_1 extends TestToolkitApplet
{

    // Events allowed and tested
    private static byte MAX_EVENT = 7; // (2 to 6, 10 and 24)
    private short[] EventList = {(short)EVENT_FORMATTED_SMS_PP_ENV, (short)EVENT_FORMATTED_SMS_PP_UPD, (short)EVENT_UNFORMATTED_SMS_PP_ENV,
                                 (short)EVENT_UNFORMATTED_SMS_PP_UPD, (short)EVENT_UNFORMATTED_SMS_CB, (short)EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,  
                                 (short)EVENT_FORMATTED_SMS_CB}; 
                        
 
     
       
    /**
     * Constructor of the applet
     */
    public Api_2_Tkr_Ievs_1()
    {
        }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        

        
        // Create a new applet instance.
        Api_2_Tkr_Ievs_1 thisApplet = new Api_2_Tkr_Ievs_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
       
        thisApplet.obReg.setEvent(EVENT_EVENT_DOWNLOAD_USER_ACTIVITY);
                                                           
   }


    public void processToolkit(short event)
    {
        
                
        boolean bRes = false;
        byte    bTestCaseNb = (byte)0;

        // -----------------------------------------------------------------
        // Test Case 1 :For events ranging from 2 to 6, 10 and 24 the
        //              applet calls :
        //              1 - isEventSet() method
        //                  Shall return false each time
        // -----------------------------------------------------------------               
            bTestCaseNb = (byte)1;
            
            bRes = true;
            for(short i=0; i < (short)(MAX_EVENT); i++) {            
            
                if (obReg.isEventSet(EventList[i])) {
                    // A cleared event should not be set anymore
                    bRes = false;
                    break;
                }
                
            }                   
            reportTestOutcome ( bTestCaseNb, bRes );

            
        // --------------------------------------------------------------------
        // Test Case 2 :For events ranging from 2 to 6, 10 and 24 the
        //              applet calls :
        //                          1 - setEvent() method   
        //              2 - isEventSet() method
        //                  Shall return true each time
        // --------------------------------------------------------------------
                        
            bTestCaseNb = (byte)2;          
            
            
            try{
            		bRes = true;
                for(short i=0; i < (short)(MAX_EVENT); i++) {
                    
                    obReg.setEvent(EventList[i]);                     
                            
                    if (!obReg.isEventSet(EventList[i])) {
                        // A cleared event should not be set anymore
                        bRes = false;
                        break;
                    }                   
                                        
                }           
            }   
            catch (Exception e) {
                bRes = false;
            }   
            reportTestOutcome ( bTestCaseNb, bRes );                        
                       

    }

}

